diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java
index ef8f5e3a6..eb1600c4f 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java
@@ -20,9 +20,9 @@ import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
 import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.monster.EntityHuman;
-import net.minecraft.core.entity.monster.EntityZombie;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.monster.HumanMob;
+import net.minecraft.core.entity.monster.ZombieMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -89,12 +89,12 @@ public class EntityCategory extends ModelViewerCategory{
     @Override
     public void addContextButtons(List<GuiButton> buttonList) {
         GuiButton lastButton = buttonList.get(buttonList.size()-1);
-        boolean isLiving = displayEntity instanceof EntityLiving;
+        boolean isLiving = displayEntity instanceof Mob;
         if (isLiving){
             entityVariant = new GuiTextCycle<Integer>(modelViewer, mc.fontRenderer, modelViewer.width - 120, lastButton.yPosition + 21, 120, 20, 0) {
                 @Override
                 public Integer cycleElement(Integer current, int offset) {
-                    return (current + offset) & 0x7F;
+                    return (current + offset) & 0xFF;
                 }
 
                 @Override
@@ -111,7 +111,7 @@ public class EntityCategory extends ModelViewerCategory{
                     return String.valueOf(element);
                 }
             };
-            entityVariant.setOnValueChanged(() -> ((EntityLiving) displayEntity).setSkinVariant(entityVariant.getCurrentElement()));
+            entityVariant.setOnValueChanged(() -> ((Mob) displayEntity).setSkinVariant(entityVariant.getCurrentElement()));
             entityVariant.textField.setPlaceholder("Variant");
             entityVariant.textField.setPrefaceText("Variant: ");
             buttonList.add(entityVariant);
@@ -151,7 +151,7 @@ public class EntityCategory extends ModelViewerCategory{
 
     @Override
     public void onOpen() {
-        currentEntry = entryMap.get(EntityZombie.class);
+        currentEntry = entryMap.get(ZombieMob.class);
         currentEntry.onOpen();
         setDisplayEntity(currentEntry.getEntityInstance(mc, mc.theWorld));
     }
@@ -168,11 +168,11 @@ public class EntityCategory extends ModelViewerCategory{
             displayEntity.tickCount++;
             getEntry(displayEntity).onTick(displayEntity);
         }
-        if (!(displayEntity instanceof EntityHuman) || System.currentTimeMillis() > modelViewer.timeLastKeyPressed + 1000){
-            if (displayEntity != null && displayEntity instanceof EntityLiving){
-                String oldNick = ((EntityLiving) displayEntity).nickname;
+        if (!(displayEntity instanceof HumanMob) || System.currentTimeMillis() > modelViewer.timeLastKeyPressed + 1000){
+            if (displayEntity != null && displayEntity instanceof Mob){
+                String oldNick = ((Mob) displayEntity).nickname;
                 if (!oldNick.equals(entityName.getText())){
-                    ((EntityLiving) displayEntity).setNickname(entityName.getText());
+                    ((Mob) displayEntity).setNickname(entityName.getText());
                 }
             }
         }
@@ -186,8 +186,8 @@ public class EntityCategory extends ModelViewerCategory{
             displayEntity.absMoveTo(mc.thePlayer.x, mc.thePlayer.y - displayEntity.bbHeight/2, mc.thePlayer.z, displayEntity.yRot, displayEntity.xRot);
             displayEntity.lerpMotion(0, 0, 0);
             mc.theWorld.entityJoinedWorld(displayEntity);
-            if (displayEntity instanceof EntityLiving){
-                ((EntityLiving) displayEntity).setSkinVariant(0);
+            if (displayEntity instanceof Mob){
+                ((Mob) displayEntity).setSkinVariant(0);
             }
         }
         mc.effectRenderer.clearEffects(mc.theWorld);
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
index 49ea7430d..4a2a5e530 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui.modelviewer.categories;
 
-import net.minecraft.client.entity.fx.ParticleDispatcher;
+import net.minecraft.client.entity.particle.ParticleDispatcher;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.gui.modelviewer.categories.entries.particle.BlockFXEntry;
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java
index ec6d09414..056256d7a 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.List;
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
index 5725909fc..765800e1f 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.List;
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java
index 7fa0c24ed..9a20b985f 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java
@@ -6,7 +6,8 @@ import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntityFlowerJar;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.FlowerJarBlockEntity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.DisplayChunk;
@@ -16,7 +17,7 @@ import java.util.List;
 
 public class JarEntry extends BlockEntry{
     public JarEntry() {
-        super(Block.jarGlass);
+        super(Blocks.JAR_GLASS);
     }
 
     @Override
@@ -50,7 +51,7 @@ public class JarEntry extends BlockEntry{
         };
         jarCycle.textField.setPrefaceText("Jar: ");
         jarCycle.textField.setPlaceholder("Jar ID");
-        jarCycle.setOnValueChanged(() -> ((TileEntityFlowerJar)DisplayChunk.displayTileEntity).flowerInPot = jarCycle.getCurrentElement());
+        jarCycle.setOnValueChanged(() -> ((FlowerJarBlockEntity)DisplayChunk.displayBlockEntity).flowerInPot = jarCycle.getCurrentElement());
 
         return new ArrayList<GuiButton>(){{add(jarCycle);}};
     }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
index 4b8bad0f2..a88e0de49 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
@@ -4,8 +4,8 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntityMobSpawner;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
@@ -16,12 +16,12 @@ import java.util.List;
 
 public class MobSpawnerEntry extends BlockEntry{
     public MobSpawnerEntry() {
-        super(Block.mobspawner);
+        super(Blocks.MOBSPAWNER);
     }
 
     @Override
     public void onTick(World world, int meta) {
-        TileEntityMobSpawner spawner = (TileEntityMobSpawner) DisplayChunk.displayTileEntity;
+        MobSpawnerBlockEntity spawner = (MobSpawnerBlockEntity) DisplayChunk.displayBlockEntity;
         spawner.yaw2 = spawner.yaw;
         double xPos = (double) spawner.x + spawner.worldObj.rand.nextFloat();
         double yPos = (double) spawner.y + spawner.worldObj.rand.nextFloat();
@@ -45,7 +45,7 @@ public class MobSpawnerEntry extends BlockEntry{
                 return element;
             }
         };
-        dispatcherIds.setOnValueChanged(() -> ((TileEntityMobSpawner)DisplayChunk.displayTileEntity).setMobId(dispatcherIds.getCurrentElement()));
+        dispatcherIds.setOnValueChanged(() -> ((MobSpawnerBlockEntity)DisplayChunk.displayBlockEntity).setMobId(dispatcherIds.getCurrentElement()));
         return new ArrayList<GuiButton>(){{add(dispatcherIds);}};
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java
index af1fba73a..0789f9652 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java
@@ -5,7 +5,7 @@ import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntitySign;
+import net.minecraft.core.block.entity.SignBlockEntity;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.DisplayChunk;
 
@@ -24,7 +24,7 @@ public class SignEntry extends BlockEntry{
 
     @Override
     public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta) {
-        TileEntitySign sign = (TileEntitySign)DisplayChunk.displayTileEntity;
+        SignBlockEntity sign = (SignBlockEntity)DisplayChunk.displayBlockEntity;
         GuiListenerTextField line1 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, 0,                       120, 20, "", "Line 1");
         GuiListenerTextField line2 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, line1.yPosition + 21,    120, 20, "", "Line 2");
         GuiListenerTextField line3 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, line2.yPosition + 21,    120, 20, "", "Line 3");
@@ -49,6 +49,6 @@ public class SignEntry extends BlockEntry{
 
     @Override
     public void onOpen(World world, int meta) {
-        DisplayChunk.setDisplayTileEntity(world, new TileEntitySign());
+        DisplayChunk.setDisplayTileEntity(world, new SignBlockEntity());
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java
index b8339e7a1..7ec452b4b 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java
@@ -4,21 +4,21 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
-import net.minecraft.core.entity.monster.EntityArmoredZombie;
+import net.minecraft.core.entity.monster.ZombieArmoredMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityArmoredZombieEntry extends EntityEntry<EntityArmoredZombie>{
+public class EntityArmoredZombieEntry extends EntityEntry<ZombieArmoredMob>{
     @Override
-    public void onTick(EntityArmoredZombie entity) {
+    public void onTick(ZombieArmoredMob entity) {
 
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityArmoredZombie armoredZombie) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, ZombieArmoredMob armoredZombie) {
         List<GuiButton> buttonList = new ArrayList<>();
         GuiListenerButton swordButton = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.armored_zombie.button.sword", false));
         swordButton.setActionListener(() -> {
@@ -31,8 +31,8 @@ public class EntityArmoredZombieEntry extends EntityEntry<EntityArmoredZombie>{
     }
 
     @Override
-    public EntityArmoredZombie getEntityInstance(Minecraft mc, World world) {
-        EntityArmoredZombie armoredZombie = new EntityArmoredZombie(world);
+    public ZombieArmoredMob getEntityInstance(Minecraft mc, World world) {
+        ZombieArmoredMob armoredZombie = new ZombieArmoredMob(world);
         armoredZombie.setHoldingSword(false);
         return armoredZombie;
     }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java
index a9b502be5..c9085d1b9 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java
@@ -4,27 +4,27 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
-import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.entity.vehicle.BoatEntity;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityBoatEntry extends EntityEntry<EntityBoat>{
+public class EntityBoatEntry extends EntityEntry<BoatEntity>{
     @Override
-    public void onTick(EntityBoat entity) {
+    public void onTick(BoatEntity entity) {
 
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityBoat entity) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, BoatEntity entity) {
         GuiListenerButton flagButton = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.boat.button.flag", false));
         flagButton.setActionListener(() -> {
             boolean flag;
             if (entity.tileEntityFlag == null){
-                entity.tileEntityFlag = new TileEntityFlag();
+                entity.tileEntityFlag = new FlagBlockEntity();
                 flag = true;
             } else {
                 entity.tileEntityFlag = null;
@@ -36,8 +36,8 @@ public class EntityBoatEntry extends EntityEntry<EntityBoat>{
     }
 
     @Override
-    public EntityBoat getEntityInstance(Minecraft mc, World world) {
-        EntityBoat boat = new EntityBoat(world);
+    public BoatEntity getEntityInstance(Minecraft mc, World world) {
+        BoatEntity boat = new BoatEntity(world);
         boat.yRot = 270f;
         boat.zd = 100; // Causes the flag to rotate when enabled
         return boat;
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java
index 2fe012e36..c495ec7ba 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java
@@ -4,21 +4,21 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
-import net.minecraft.core.entity.monster.EntityCreeper;
+import net.minecraft.core.entity.monster.CreeperMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityCreeperEntry extends EntityEntry<EntityCreeper>{
+public class EntityCreeperEntry extends EntityEntry<CreeperMob>{
     @Override
-    public void onTick(EntityCreeper entity) {
+    public void onTick(CreeperMob entity) {
 
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityCreeper creeper) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, CreeperMob creeper) {
         List<GuiButton> buttonList = new ArrayList<>();
         boolean isCharged = creeper.getPowered();
         GuiListenerButton chargedToggle = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.creeper.button.charged", isCharged));
@@ -33,8 +33,8 @@ public class EntityCreeperEntry extends EntityEntry<EntityCreeper>{
     }
 
     @Override
-    public EntityCreeper getEntityInstance(Minecraft mc, World world) {
-        return new EntityCreeper(world);
+    public CreeperMob getEntityInstance(Minecraft mc, World world) {
+        return new CreeperMob(world);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
index 1b7a020b0..12258c0f6 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
@@ -6,21 +6,21 @@ import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.EntityFallingSand;
-import net.minecraft.core.util.helper.MathHelper;
+
+import net.minecraft.core.entity.FallingBlockEntity;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityFallingSandEntry extends EntityEntry<EntityFallingSand>{
+public class EntityFallingSandEntry extends EntityEntry<FallingBlockEntity>{
     @Override
-    public void onTick(EntityFallingSand entity) {
+    public void onTick(FallingBlockEntity entity) {
 
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityFallingSand sand) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, FallingBlockEntity sand) {
         GuiTextCycle<Integer> blockIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, 0, 120, 20, sand.blockID) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
@@ -48,8 +48,8 @@ public class EntityFallingSandEntry extends EntityEntry<EntityFallingSand>{
     }
 
     @Override
-    public EntityFallingSand getEntityInstance(Minecraft mc, World world) {
-        return new EntityFallingSand(world);
+    public FallingBlockEntity getEntityInstance(Minecraft mc, World world) {
+        return new FallingBlockEntity(world);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
index 6fde34902..f310e30f3 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
@@ -5,7 +5,7 @@ import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 
@@ -13,9 +13,9 @@ import java.util.ArrayList;
 import java.util.List;
 import java.util.Random;
 
-public class EntityFireflyEntry extends EntityEntry<EntityFireflyCluster>{
+public class EntityFireflyEntry extends EntityEntry<FireflyClusterMob>{
     @Override
-    public void onTick(EntityFireflyCluster fireflyCluster) {
+    public void onTick(FireflyClusterMob fireflyCluster) {
         Random random = fireflyCluster.world.rand;
         double dy = (random.nextFloat() * 2F - 1F) * (fireflyCluster.bbHeight);
         double dx = (random.nextFloat() * 2F - 1F) * (fireflyCluster.bbWidth);
@@ -27,7 +27,7 @@ public class EntityFireflyEntry extends EntityEntry<EntityFireflyCluster>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityFireflyCluster fireflyCluster) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, FireflyClusterMob fireflyCluster) {
         List<GuiButton> buttonList = new ArrayList<>();
         GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.fireflycluster.slider.size", 0), 0f);
         slider.setOnValueChanged(() -> {
@@ -35,9 +35,9 @@ public class EntityFireflyEntry extends EntityEntry<EntityFireflyCluster>{
             slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.fireflycluster.slider.size", fireflyCluster.getClusterSize());
         });
 
-        GuiListSelectorButton<EntityFireflyCluster.FireflyColor> button = new GuiListSelectorButton<EntityFireflyCluster.FireflyColor>(-1, - 120, slider.yPosition + 21, 120, 20, I18n.getInstance().translateKey("model.category.entity.fireflycluster.button.cycle"), EntityFireflyCluster.FireflyColor.fireFlyColors.values(), EntityFireflyCluster.FireflyColor.GREEN) {
+        GuiListSelectorButton<FireflyClusterMob.FireflyColor> button = new GuiListSelectorButton<FireflyClusterMob.FireflyColor>(-1, - 120, slider.yPosition + 21, 120, 20, I18n.getInstance().translateKey("model.category.entity.fireflycluster.button.cycle"), FireflyClusterMob.FireflyColor.fireFlyColors.values(), FireflyClusterMob.FireflyColor.GREEN) {
             @Override
-            public String getNameFromElement(EntityFireflyCluster.FireflyColor element) {
+            public String getNameFromElement(FireflyClusterMob.FireflyColor element) {
                 return element.getParticleName();
             }
         };
@@ -48,8 +48,8 @@ public class EntityFireflyEntry extends EntityEntry<EntityFireflyCluster>{
     }
 
     @Override
-    public EntityFireflyCluster getEntityInstance(Minecraft mc, World world) {
-        EntityFireflyCluster cluster = new EntityFireflyCluster(world);
+    public FireflyClusterMob getEntityInstance(Minecraft mc, World world) {
+        FireflyClusterMob cluster = new FireflyClusterMob(world);
         cluster.setClusterSize(0);
         return cluster;
     }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java
index aefb08c79..8aada06d3 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java
@@ -6,8 +6,8 @@ import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
 import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
@@ -17,16 +17,16 @@ import net.minecraft.core.world.World;
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityItemEntry extends EntityEntry<EntityItem>{
+public class EntityItemEntry extends EntityEntry<ItemEntity>{
     @Override
-    public void onTick(EntityItem entityItem) {
-        entityItem.age++;
+    public void onTick(ItemEntity itemEntity) {
+        itemEntity.age++;
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityItem entityItem) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, ItemEntity itemEntity) {
         List<GuiButton> buttonList = new ArrayList<>();
-        entityItem.item = Block.stone.getDefaultStack();
+        itemEntity.item = Blocks.STONE.getDefaultStack();
         GuiTextCycle<Integer> itemIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, 0, 120, 20, 1) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
@@ -39,7 +39,7 @@ public class EntityItemEntry extends EntityEntry<EntityItem>{
                     int id = Integer.parseInt(s);
                     return MathHelper.clamp(id, 0, Item.itemsList.length);
                 } catch (Exception ignored){}
-                return entityItem.item.itemID;
+                return itemEntity.item.itemID;
             }
 
             @Override
@@ -62,7 +62,7 @@ public class EntityItemEntry extends EntityEntry<EntityItem>{
                     int id = Integer.parseInt(s);
                     return MathHelper.clamp(id, 0, 0x3FFF);
                 } catch (Exception ignored){}
-                return entityItem.item.getMetadata();
+                return itemEntity.item.getMetadata();
             }
 
             @Override
@@ -74,12 +74,12 @@ public class EntityItemEntry extends EntityEntry<EntityItem>{
         metaCycle.textField.setPlaceholder("Meta");
         GuiListenerSlider sizeSlider = new GuiListenerSlider(-1, - 120, metaCycle.yPosition + 21,120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.item.slider.size", 1), 1/64f);
 
-        itemIdCycle.setOnValueChanged(() -> entityItem.item = new ItemStack(itemIdCycle.getCurrentElement(), (int) (sizeSlider.sliderValue * 64), metaCycle.getCurrentElement()));
-        metaCycle.setOnValueChanged(() -> entityItem.item = new ItemStack(itemIdCycle.getCurrentElement(), (int) (sizeSlider.sliderValue * 64), metaCycle.getCurrentElement()));
+        itemIdCycle.setOnValueChanged(() -> itemEntity.item = new ItemStack(itemIdCycle.getCurrentElement(), (int) (sizeSlider.sliderValue * 64), metaCycle.getCurrentElement()));
+        metaCycle.setOnValueChanged(() -> itemEntity.item = new ItemStack(itemIdCycle.getCurrentElement(), (int) (sizeSlider.sliderValue * 64), metaCycle.getCurrentElement()));
 
         sizeSlider.setOnValueChanged(() -> {
-            entityItem.item.stackSize = (int) (sizeSlider.sliderValue * 64);
-            sizeSlider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.item.slider.size", entityItem.item.stackSize);
+            itemEntity.item.stackSize = (int) (sizeSlider.sliderValue * 64);
+            sizeSlider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.item.slider.size", itemEntity.item.stackSize);
         });
 
         buttonList.add(itemIdCycle);
@@ -89,8 +89,8 @@ public class EntityItemEntry extends EntityEntry<EntityItem>{
     }
 
     @Override
-    public EntityItem getEntityInstance(Minecraft mc, World world) {
-        return new EntityItem(world);
+    public ItemEntity getEntityInstance(Minecraft mc, World world) {
+        return new ItemEntity(world);
     }
 
     @Override
